<?php
/**
 * Copyright (C) 2021  Jaap Jansma (jaap.jansma@civicoop.org)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

namespace Civi\Api4\Action\PhoneInputMask;

use Civi\Api4\Generic\AbstractAction;
use Civi\Api4\Generic\Result;

class CheckName extends AbstractAction {

  /**
   * @var integer
   */
  protected $id = null;

  /**
   * @var string
   */
  protected $title;

  /**
   * @var string
   */
  protected $name = '';

  /**
   * Check whether a name is available and/or convert a title into a name.
   *
   * @param Result $result
   */
  public function _run(Result $result) {
    $name = \CRM_Phoneinputmask_BAO_PhoneInputMask::checkName($this->title, $this->id, $this->name);
    $result[] = ['name' => $name];
  }


}
